winstd::sec_credentials Class Reference
Security API

PCredHandle wrapper class. More...

`#include <WinStd/Sec.h>`

Inheritance diagram for winstd::sec_credentials:

## Public Member Functions

| sec_credentials ()
| Initializes a new class instance with the object handle set to NULL.
| sec_credentials (handle_type h, const TimeStamp expires)
| Initializes a new class with an already available object handle. More...
| sec_credentials (sec_credentials &&h) noexcept
| Move constructor. More...
virtual | ~sec_credentials ()
| Frees the security credentials. More...
sec_credentials & | operator= (sec_credentials &&h) noexcept
| Move assignment. More...
SECURITY_STATUS | acquire (LPTSTR pszPrincipal, LPTSTR pszPackage, unsigned long fCredentialUse, void *pvLogonId, void *pAuthData, SEC_GET_KEY_FN pGetKeyFn=NULL, void *pvGetKeyArgument=NULL)
| Acquires the security credentials. More...
Public Member Functions inherited from winstd::handle< PCredHandle, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (handle_type h) const
| Is handle less than? More...
bool | operator<= (handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (handle_type h) const
| Is handle greater than? More...
bool | operator!= (handle_type h) const
| Is handle not equal to? More...
bool | operator== (handle_type h) const
| Is handle equal to? More...
void | attach (handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Public Attributes

TimeStamp | m_expires
| Credentials expiration time.

## Protected Member Functions

void | free_internal () noexcept override
| Frees the security credentials. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members

Public Types inherited from winstd::handle< PCredHandle, NULL >
typedef PCredHandle | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< PCredHandle, NULL >
static const PCredHandle | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< PCredHandle, NULL >
handle_type | m_h
| Object handle.

## Detailed Description

PCredHandle wrapper class.

## Constructor & Destructor Documentation

## sec_credentials() [1/2]

winstd::sec_credentials::sec_credentials | ( | handle_type | h,
|  | const TimeStamp | expires
| ) |  |

inline

Initializes a new class with an already available object handle.

Parameters

  [in] | h | Initial class handle value
  [in] | expires | Credentials expiration

## sec_credentials() [2/2]

winstd::sec_credentials::sec_credentials | ( | sec_credentials && | h | ) |

inlinenoexcept

Move constructor.

Parameters

  [in,out] | h | A rvalue reference of another object

## ~sec_credentials()

virtual winstd::sec_credentials::~sec_credentials | ( |  | ) |

inlinevirtual

Frees the security credentials.

See also
  FreeCredentialsHandle function

## Member Function Documentation

## acquire()

SECURITY_STATUS winstd::sec_credentials::acquire | ( | LPTSTR | pszPrincipal,
|  | LPTSTR | pszPackage,
|  | unsigned long | fCredentialUse,
|  | void * | pvLogonId,
|  | void * | pAuthData,
|  | SEC_GET_KEY_FN | pGetKeyFn = `NULL`,
|  | void * | pvGetKeyArgument = `NULL`
| ) |  |

inline

Acquires the security credentials.

Returns
  - `SEC_E_OK` when succeeds;
  - Error code when fails.

See also
  AcquireCredentialsHandle (General) function

## free_internal()

void winstd::sec_credentials::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Frees the security credentials.

See also
  FreeCredentialsHandle function

Implements winstd::handle< PCredHandle, NULL >.

## operator=()

sec_credentials & winstd::sec_credentials::operator= | ( | sec_credentials && | h | ) |

inlinenoexcept

Move assignment.

Parameters

  [in,out] | h | A rvalue reference of another object

The documentation for this class was generated from the following file:

- include/WinStd/Sec.h